// pages/exchange/exchange.js
import { userEntityRecharge } from '../../api/charge'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    cardNo: '',
    cardSecret: ''
  },


  /**
   * 确认提交充值
   */
  handleComfirm() {
    var cardNo = this.data.cardNo
    var cardSecret = this.data.cardSecret
    console.log(cardNo, cardSecret);
    if (cardNo == '') {
      wx.showToast({
        title: '请输入卡号',
        icon: 'error'
      })
      return
    } else if (cardSecret == '') {
      wx.showToast({
        title: '请输入卡密',
        icon: 'error'
      })
      return
    } else {
      var data = {
        cardNo: cardNo,
        cardSecret: cardSecret
      }
      wx.showLoading({
        title: '充值中...',
        mask: true
      })
      userEntityRecharge(data).then(res => {
        console.log(res, 'userEntityRecharge');
        wx.hideLoading()
        w.showToast({
          title: '充值成功',
          icon: 'success'
        })
      }).catch(e => {
        wx.hideLoading()
        wx.showModal({
          content: e,
          confirmColor: '#333',
          showCancel: false
        })
      })
    }
  },

  bindCardNo(e) {
    this.setData({
      cardNo: e.detail.value
    })
  },

  bindCardPwd(e) {
    this.setData({
      cardSecret: e.detail.value
    })
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  handleCancle() {
    wx.navigateBack()
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})